
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color7 Red
#property indicator_color6 Blue
#property indicator_color3 DarkSlateGray
#property indicator_color4 SlateGray
#property indicator_color5 DarkGreen
#property indicator_color1 DarkSlateGray
#property indicator_color2 SlateGray
#property indicator_color8 Goldenrod
#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 0
#property indicator_style4 0
#property indicator_style5 0
#property indicator_style6 0
#property indicator_style7 0
#property indicator_style8 0
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1

extern int TimeFrame=240;
extern int Tenkan=9;
extern int Kijun=26;
extern int Senkou=52;
extern bool tenkan=true;
extern bool tenkan_S=true;
extern bool kijun=false;
extern bool senkou=false;
extern bool chinkou=false;
extern bool label=true;
extern int AlertMode=0;
extern int BackStep=0;
extern bool pouring = false;
extern bool Comments = false;
extern int Complect=2;
extern bool showArrows = false;
extern int       UpDnArrowSize  = 2;
extern bool      showArrows1         = false;
extern int       UpDnArrowSize1  = 0;
extern double    Signal_Gap=  0.01;
extern color     ArrowUpColor = LimeGreen;
extern color     ArrowDnColor = Red;

double Tenkan_Buffer[];
double Tenkan_Buffer_1[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
int a_begin;
int init()
  {

   if(tenkan)
   {
   SetIndexStyle(6,DRAW_LINE);
   }
else SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(6,Tenkan_Buffer);
   SetIndexDrawBegin(6,Tenkan-1);
   SetIndexLabel(6,"Tenkan Sen  "+TimeFrame);
   
   if(tenkan_S)
   {
   SetIndexStyle(7,DRAW_LINE);
   }
else SetIndexStyle(7,DRAW_NONE);
   SetIndexBuffer(7,Tenkan_Buffer_1);
   SetIndexDrawBegin(7,Tenkan-1);
   SetIndexLabel(7,"Tenkan Sen S  "+TimeFrame);
//----
   if(kijun)
   {
   SetIndexStyle(5,DRAW_LINE);
   }
else SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,Kijun_Buffer);
   SetIndexDrawBegin(5,Kijun-1);
   SetIndexLabel(5,"Kijun Sen  "+TimeFrame);
//----
   
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;
   
   if (pouring)
   {
   if(senkou)
   {
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT);
   }
else SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,SpanA_Buffer);
   SetIndexDrawBegin(2,Kijun+a_begin-1);
   SetIndexShift(2,Kijun);
   SetIndexLabel(2,NULL);
   }
   if(senkou)
   {
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
   }
else SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,SpanA2_Buffer);
   SetIndexDrawBegin(0,Kijun+a_begin-1);
   SetIndexShift(0,Kijun);
   SetIndexLabel(0,"Senkou Span A  "+TimeFrame);
//----
   if (pouring)
   {
   if(senkou)
   {
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_DOT);
   }
else SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(3,SpanB_Buffer);
   SetIndexDrawBegin(3,Kijun+Senkou-1);
   SetIndexShift(3,Kijun);
   SetIndexLabel(3,NULL);
   }
   if(senkou)
   {
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   }
else SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,SpanB2_Buffer);
   SetIndexDrawBegin(1,Kijun+Senkou-1);
   SetIndexShift(1,Kijun);
   SetIndexLabel(1,"Senkou Span B  "+TimeFrame);
//----
   if(chinkou)
   {
   SetIndexStyle(4,DRAW_LINE);
   }
else SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,Chinkou_Buffer);
   SetIndexShift(4,-Kijun);
   SetIndexLabel(4,"Chinkou Span  "+TimeFrame);

switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("IchimokuAlert ("+TimeFrameStr+")");

  }
//----
   return(0);


int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
     
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++) {
     if (Time[i]<TimeArray[y]) {y++;}   

     SpanA2_Buffer[i+Kijun]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,0,y); 
     SpanB2_Buffer[i+Kijun]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,1,y); 
     SpanB_Buffer[i+Kijun]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,3,y); 
     SpanA_Buffer[i+Kijun]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,2,y); 
     Chinkou_Buffer[i-Kijun]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,4,y); 
     Kijun_Buffer[i]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,5,y); 
     Tenkan_Buffer[i]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,6,y); 
     Tenkan_Buffer_1[i]=iCustom(NULL,TimeFrame,"TISA",Tenkan,Kijun,Senkou,tenkan,tenkan_S,kijun,senkou,chinkou,label,AlertMode,BackStep,pouring,Comments,Complect,showArrows,UpDnArrowSize,showArrows1,UpDnArrowSize1,Signal_Gap,ArrowUpColor,ArrowDnColor,7,y); 
   }
   
   
  
   
   return(0);
  }